<?php
// ***************************************************************
//*  Basic module for pky Serial Applications V1.00
//*                     
//*  History:          
//*  Build PHP4, Puterkey                        [2003-03-05] 
//*         
//*  CUserApp                 
//*****************************************************************//

class CUserApp
{
	var $set;
	var $tplPath;
	var $siteTitle;
	var $input = array();
    var $sess = array();
	var $code = "<\?die();?\>";

	function getTemplate($template,$EXT="htm") 
    {
    	return str_replace("\"","\\\"",implode("",file($this->tplPath."/".$template.".".$EXT)));
    }

	function outPut($template,$showFooter="y")
    {
    	if ($showFooter == "y")  $template .= $this->footer();
    	echo $template;
    }

	function safeChars($msg) 
    {
        $msg = trim($msg);
        $msg = stripslashes($msg);
        $msg = str_replace("\x0E", "*", $msg);
        $msg = str_replace("", "*", $msg);
        $msg = str_replace("|", "&#124;", $msg); 
        $msg = str_replace(">", "&gt;", $msg);
        $msg = str_replace("<", "&lt;", $msg);
        $msg = str_replace("\n", "<br>", $msg);
        $msg = str_replace("\t","",$msg);
        $msg = str_replace("\r","",$msg);

    	return $msg;
    }

	function checkEmail($email) 
    {
    	if (ereg("^.+@.+\\..+$",$email)) return 1;
        else return 0;
    }

	function showMsg($msg,$url='')
    { 
    	if ($url == "")  $url = "javascript:history.go(-1);";
        if("ask" == $url) 
		{
            $action2 = $this->input['action']."2";
            eval("\$this->outPut(\"".$this->getTemplate("moderateMsg")."\",\"n\");");
        }
		else 
		{
            eval("\$this->outPut(\"".$this->getTemplate("msg")."\",\"n\");");
        }
    	exit;
    }

	function adminShowMsg($url,$msg)
    {
    	eval("\$this->output(\"".$this->getTemplate("msg")."\");");
    	exit;
    } 

	function adminShowWrong($url,$msg)
    {
    	eval("\$this->output(\"".$this->getTemplate("wrong")."\");");
    	exit;
    }

	function strCat($sender)
	{
      $len = strlen($sender);
      if ($len <= $this->set[listnumNameLen]) return $sender;
     else
     {
       $sender = substr($sender, 0, $this->set[listnumNameLen]); 
       $parity= 0;
       for($j=0; $j < $this->set[listnumNameLen]; $j++)
       { 
         $temp_str=substr($sender, $j, 1); 
         if(Ord($temp_str) > 127) $parity += 1; 
        } 
        if($parity%2 == 1) $sender=substr($sender, 0, ($this->set[listnumNameLen] - 1))."..."; 
        else $sender = substr($sender, 0, $this->set[listnumNameLen])."..."; 
      }
	  return $sender;
	}

	function Header($modName)
	{
	  eval ("\$result .= \"".$this->getTemplate("header")."\";");
	  return $result;
	}

	function Footer()
	{
	  $copyright = "<br>Copyright &copy 2001-2003 PuterKey.COMּͥ All Rights Reserved.";
	  $version = "V2.0 Build 20030315";
	  eval ("\$result = \"".$this->getTemplate("footer")."\";");        
      return $result;
	}

    function checkLogin()
	{
	  // cookie[û/]Ϊ, ת¼ҳ
	  $username = $this->sess['PDUserName'];
	  $password = $this->sess['PDPassword'];
      if ($username=="" || $password=="")
      {
		$this->showMsg("Բû¼¼ȣ","admin.php?modules=user&action=login");
      }

    // ûµ
    $aUser = new CUser;
    $aUser->open();
    if(!$aUser->findByName($username)) $this->showMsg("ѵ¼ûǷǷģµ¼", "admin.php?modules=user&action=login");
    $user_password = $aUser->password;
    $aUser->close();

      // cookie[]ȷ, ת¼ҳ
      if ($user_password != ($password)) $this->showMsg("ѵ¼û벻ȷµ¼", "admin.php?modules=user&action=login");
	}

	function showNew($categoryid, $classid)
    {
      $aSoft = new CSoft;
      $aSoft->open();
      $aClass = new CClass;
      $aClass->open();
      $posList = $aSoft->FilterByClass($categoryid, $classid, "1", $this->set[listnumNew]);

      $box_title = "[{$this->set[listnumNew]}]";
      for($i = 0; $i < count($posList); $i ++)
      {
	    $id = $posList[$i];
	    $aSoft->setAbsolutePosition($id);
        //ȡС
        $aClass->find($aSoft->class_id);
        $type2 = $aClass->class_name;
        $sort1id = $aClass->class_category_id;
        $name = $this->strCat($aSoft->name);
		$updatetime = date($this->set[dateformat], $aSoft->updatetime);
		$str = "[<a href = index.php?modules=list&categoryid=$aSoft->category_id&classid=$aSoft->class_id>$type2</a>]&nbsp;&nbsp;";
	    $box_content .=  "<a href=index.php?modules=show&id=$id target = _blank title={$aSoft->name}>$name</a>(<font color = red>$updatetime</font>)<br>";
      }	  
	  $aClass->close();	 
      $aSoft->close();
	  eval ("\$new .= \"".$this->getTemplate("box")."\";");
	  return $new;
    }

	function showDownTop($categoryid, $classid)
	{
	  $aSoft = new CSoft;
      $aSoft->open();
      $posList = $aSoft->OrderByDownNum($categoryid, $classid);
	  $box_title = "[{$this->set[listnumDownTop]}]";

      for($i = 0; $i< min($this->set[listnumDownTop], count($posList)); $i ++)
      {
         $serial = $i + 1;
         $aSoft->setAbsolutePosition($posList[$i]);   
		 $name = $this->strCat($aSoft->name);
         $box_content .= "$serial.<a href=index.php?modules=show&id=$posList[$i] target = _blank title={$aSoft->name}>$name</a>(<font color = red>$aSoft->downnum</font>)<br>";
      }
      $aSoft->close();
	  eval ("\$downtop .= \"".$this->getTemplate("box")."\";");
	  return $downtop;
	}

	function showComment($categoryid, $classidl)
    {
      $aSoft = new CSoft;
      $aSoft->open();
      $posList = $aSoft->FilterByComment($categoryid, $classid, $this->set[listnumComment]);
      $box_title = "Ƽ[{$this->set[listnumComment]}]";
      for($i = 0; $i < count($posList); $i ++)
      {
	    $serial = $i + 1;
	    $id = $posList[$i];
	    $aSoft->setAbsolutePosition($id);
	    $name = $this->strCat($aSoft->name);
         $box_content .= "$serial.<a href=index.php?modules=show&id=$posList[$i] target = _blank title={$aSoft->name}>$name</a>(<font color = red>$aSoft->downnum</font>)<br>";
      }	  
      $aSoft->close();
	  eval ("\$comment .= \"".$this->getTemplate("box")."\";");
	  return $comment;
    }

	function getPages($num, $setpage, $setid, $url)
	{
      // ҳ 
      $pages = ceil($num/$this->set[listnumPage]);
      $page = ceil($pages/$this->set[listnumSegment]);

      $result .= "๲{$num}{$pages}ҳÿҳ{$this->set[listnumPage]}-=>";

      if ($setid > 0)
      {
        $setpage1 = ceil($setid/$this->set[listnumPage]);
        $setpage = ceil(($setpage1+1)/$this->set[listnumSegment]);
      }
      else
      {
        $setpage = 1;
      }

      if ($pages > $this->set[listbnumSegment])$pagenum = $this->set[listnumSegment];
      else $pagenum = $pages;

      $issetid = ceil(($setid+1)/$this->set[listnumPage]);
      $issetpage = $issetid % $this->set[listnumSegment];

      // һҳ
      if ($setpage > 1)  $result .= "<a title='һҳ' href='{$url}&setpage=1&setid=0'>[1]</a>...\n";

      // һ
      if ($setpage>1)
     {
        $lastpage = $setpage-1;
        $lastsetid = ($setpage-2)*$this->set[listnumSegment]*$this->set[listnumPage];
        $result .= "<a title='һ' href='{$url}&setpage={$lastpage}&setid={$lastsetid}'>[<<]</a> - \n";
      }

      // һҳ
      if ($setid > 0)
      {
        if ($issetpage == 1) $newsetpage = $setpage-1;
        else $newsetpage = $setpage;
  
        $presetid = $setid-$this->set[listnumPage];
        $result .= "<a title='һҳ' href='{$url}&setpage={$newsetpage}&setid={$presetid}'>[<]</a> \n";
      }

      // гҳ
      $i1 = ($setpage-1)*$this->set[listnumSegment];
      for ($i=$i1; $i<($i1+$pagenum) && $i<$pages; $i++)
      {
        $newsetid=$this->set[listnumPage]*$i;

        if (($setid/$this->set[listnumPage]) == $i) $result .= "<b><font color=red>[".($i+1)."]</font></b> \n";
        else  $result .= "<a href='{$url}&setpage={$setpage}&setid={$newsetid}'>[".($i+1)."]</a> \n";
      }

      // һҳ
      if ($pages!=0 && ($setid/$this->set[listnumPage]+1)!=$pages && ($setid/$this->set[listnumPage]+1)<=$pages||$setid==1)
      {
        if ($this->set[listnumSegment]-$issetpage == 0 || $issetpage == 0) $newsetpage = $setpage+1;
        else $newsetpage = $setpage;

        $newsetid = $setid+$this->set[listnumPage];
        $result .= "<a title='һҳ' href='{$url}&setpage={$newsetpage}&setid={$newsetid}'>[>]</a> \n";
      }

      // һ
      if ($pages!=0 && $pages>$this->set[listnumSegment] && $setpage<$page)
      {
        $nextpage = $setpage+1;
        $nextsetid = $setpage*$this->set[listnumSegment]*$this->set[listnumPage];
        $result .= "- <a title='һ' href='{$url}&setpage={$nextpage}&setid={$nextsetid}'>[>>]</a>\n";
      }

      // һҳ
      if ($pages>$this->set[listnumSegment] && $setpage<$page)
      {
        $lastpage = $this->set[listnumPage]*($pages-1);
        $result .= "...<a title='һҳ' href='{$url}&setpage={$page}&setid={$lastpage}'>[".$pages."]</a>\n";
      }
	  return $result;
	}

  function printBanner($currentForm, $currentType, $url)
  {
    $aCategory = new CCategory;
    $aCategory->open();
    $aClass = new CClass;
    $aClass->open();
    $category = "<img src={$this->tplPath}/images/edit.gif><a href = {$this->set[sysPath]}>{$this->set[sysTitle]}</a>&nbsp;&nbsp;";
    $aCategory->moveFirst();
    for($i = 0; $i < $aCategory->getRecordCount(); $i ++)
    {
      $formid = $aCategory->getAbsolutePosition();
	  if($currentForm == $formid && $currentType == "")
       $category .=  "<img src={$this->tplPath}/images/edit.gif><b>$aCategory->category_name</b>&nbsp;&nbsp;";
      else
	    $category .=  "<img src={$this->tplPath}/images/edit.gif><a href = {$url}&categoryid=$formid>$aCategory->category_name</a>&nbsp;&nbsp;";
	  $aCategory->moveNext();
    }
    if(empty($currentForm))
    {
      $class .= "ֹ&nbsp;<a href = {$this->set[webPath]}>{$this->set[webName]}</a>&nbsp;{$this->set[sysTitle]}";
    }
    else
    {
      if(!$aCategory->find($currentForm)) errorview("IDǷ");
	  $posList = $aClass->FilterByCategory($currentForm);
	  for($j = 0; $j < count($posList); $j ++)
	  {
	    $aClass->setAbsolutePosition($posList[$j]);
	    if($posList[$j] == $currentType)
          $class .=  "<img src={$this->tplPath}/images/dottype1.gif>&nbsp;<b>$aClass->class_name</b>&nbsp;&nbsp;";
	    else
	      $class .=  "<img src={$this->tplPath}/images/dottype.gif>&nbsp;<a href=  {$url}&categoryid=$aClass->class_category_id&classid=$posList[$j]>$aClass->class_name</a>&nbsp;&nbsp;"; 
	  }
    }

	//תб
	$aCategory->moveFirst();
    for($i = 0; $i < $aCategory->getRecordCount(); $i++)
    {
      $id = $aCategory->getAbsolutePosition();
	  if($id == $currentForm) 
	  {
	    $searchClass .= "<option value=$id selected>----".$aCategory->category_name."----</option>\n";
		$gotoClass .= "<option value={$url}&categoryid={$id} selected>----".$aCategory->category_name."----</option>\n";
	  }
      else 
	  {
	    $searchClass .= "<option value=$id>----".$aCategory->category_name."----</option>\n";
		$gotoClass .= "<option value={$url}&categoryid={$id}>----".$aCategory->category_name."----</option>\n";
	  }
	  
      //ѯС
      $posList = $aClass->FilterByCategory($id);  
      for($j = 0; $j <  count($posList); $j ++)
      {
        $aClass->setAbsolutePosition($posList[$j]);
        if($currentType == $posList[$j] ) 
		{
		  $searchClass .= "<option value='".$posList[$j]."' selected>".$aClass->class_name."</option>\n";
		  $gotoClass .= "<option value={&url}&categoryid=$id&classid=$posList[$j] selected>".$aClass->class_name."</option>\n";
		 }
	    else
		{
		  $searchClass .=  "<option value='".$posList[$j]."'>".$aClass->class_name."</option>\n";
		  $gotoClass .= "<option value={$url}&categoryid=$id&classid=$posList[$j]>".$aClass->class_name."</option>\n";
		 }
      }
      $aCategory->moveNext();
    }
    ///
	$aSoft = new CSoft;
	$aSoft->open();
	$allNum = $aSoft->getRecordCount();
	$aSoft->close();
	if($currentType != "") 
	{
	  if(!$aClass->find($currentType)) $this->showMsg("ԲҪ鿴СIDǷ", "");
	  $classNum = $aClass->class_total;
	}elseif($currentForm != "")
	{
	  if(!$aCategory->find($currentForm)) $this->showMsg("ԲҪ鿴ĴIDǷ", "");
	  $classNum = $aCategory->category_total;
	}else
	{
	  $classNum = $allNum;
	}
    $aClass->close();
    $aCategory->close();
	eval ("\$result .= \"".$this->getTemplate("banner")."\";");
	return $result;
  }
       
  function getAdminMenu()
  {
    $aUser = new CUser;
    $aUser->open();
    if(!$aUser->findByName($this->sess[PDUserName])) $this->showMsg("ǰ¼ûΪǷûµ¼", "admin.php?modules=user&action=login");
    $mygroupid = $aUser->groupid;
    $aUser->close();

     if ($mygroupid == "1")
    {
      $groupMenu .=  "<img src='{$this->tplPath}/images/edit.gif'> <a  href='./admin.php?modules=append&action=showMove'>  ת </a><br><br>\n";
      $groupMenu .=  "<img src='{$this->tplPath}/images/move.gif'> <b><a href='./admin.php?modules=sort'>   </a></b><br><br>\n";
      $groupMenu .=  "<img src='{$this->tplPath}/images/move.gif'> <b><a  href='./admin.php?modules=user'>   </a></b><br><br>\n";
      $groupMenu .=  "<img src='{$this->tplPath}/images/move.gif'> <b><a  href='./admin.php?modules=append&action=showOptions'>   </a></b><br><br>\n";
	  $groupMenu .=  "<img src='{$this->tplPath}/images/move.gif'> <b><a  href='./admin.php?modules=append&action=showBatch'>   </a></b><br><br>\n";
    }
    else
    {
      $groupMenu .=  "<img src='{$this->tplPath}/images/move.gif'> <b><a href='./admin.php?modules=user&action=showPass'>   </a></b><br><br>\n";
    }
	eval ("\$adminMenu .= \"".$this->getTemplate("adminMenu")."\";");
	return $adminMenu;
  }
  
  function getOptionCategory($selected = "")
  {
    $aCategory = new CCategory;
	$aCategory->open();
	$aCategory->moveFirst();
    for($i = 0; $i <$aCategory->getRecordCount(); $i++)
    {
      $id = $aCategory->getAbsolutePosition();
	  if($id == $selected) $result .= "<option value='$id' selected>$aCategory->category_name</option>\n";
      else $result .= "<option value='$id'>$aCategory->category_name</option>\n";
      $aCategory->moveNext();
    }
	$aCategory->close();
	return $result;
  }

  function getOptionClass()
  {
    $aCategory = new CCategory;
	$aCategory->open();	
    $aClass = new CClass;
    $aClass->open();

	$aCategory->moveFirst();
	for($j = 0; $j < $aCategory->getRecordCount(); $j ++)
	{
	  $cid = $aCategory->getAbsolutePosition();
	  $result .= "<option value=''>-=".$aCategory->category_name."=-</option>\n";
	  $aClass->moveFirst();
      for($i = 0; $i < $aClass->getRecordCount(); $i ++)
      {
	    if($aClass->class_category_id == $cid)
		{
          $id = $aClass->getAbsolutePosition();
          $result .= "<option value=".$id.">".$aClass->class_name."</option>\n";
		}
        $aClass->moveNext();
      }
	  $aCategory->moveNext();
	}
    $aClass->close();
	$aCategory->close();
	return $result;
  }

}// end class

?>